using namespace std;
#include <iostream>
#include <fstream>
#include "rv_generate.h"
#include "BS.h"
#include "MS.h"
#include "LINK.h"
#include "channel.h"
#include "sector.h"



unsigned long _seed = 100000;
Rand randnum((unsigned long long int)_seed);

int num_drop;
int run_times;
int num_compute_coef;
int test_environment;
int pathloss_model;
int num_neighbor;
double grid_interval;

int TYPE;
int num_BS;
int num_MS;
int num_MS_persector;
int num_SECTORS;
int num_LINK;
int BS_M, BS_N, BS_Mg, BS_Ng;  /// tx antenna element
int MS_M, MS_N, MS_Mg, MS_Ng;  /// rx antenna element
int NUM_RX;
int NUM_TX;
int Scheduling_Type;
int scenario;
int Configuration_Type; /// For IMT-2020
int Channel_Model_Type; /// For IMT-2020
int CH_CAL;


char * file_name;

double user_speed;
double W;
double h;
double Frequency;
double Total_BS_Tx_power;
double Wavelength;
double bs_maxpower;
double ms_maxpower;
double max_antgain;
double bandwidth;
double noise;
double BS_noisefig;
double MS_noisefig;
double ue_antenna_element_gain;
double bs_height;
double ms_height;
double ms_height_out;
double ms_height_in;

int num_floor;
int num_propagation_condition;

double inter_site_distance;
double min_distance;
double ANGLE_tilt;
double MAX_v_angle;

void Set_Parameter();
void Initialdrop();

// MU MIMO
int               *** pppPMI_map;
double            *** pppCQI_Map;
int num_rbs_in_1ms = 50;
int cqi_history_length = 8;


int       mx_ue_mumimo = 2;
double epsilon = 0.4;   ///  configuration   0.2 , Ʈ 0.4 Ǿִ...
int    mcs_decision = 1;
Matrix4cd WW[16];
Vector4cd code_word[64];

// simulation run variables
int t;
int drop_idx;

// simulation configure variables

int SCHEDULE_DELAY = 5;

//int run_times = 2000;
//int SCHEDULE_DELAY = 5;
int precalculate_time = 2000;
int anglev_mapping_value = 3;


complex <double> **** CHIR_precalc[2][2];
MatrixXcd **Hm[2][2];
int ** PMI_precalc[20000][2][2];
double **sinr_estimate_precalc[20000][2][2];
double **sum_of_ch_coef_precalc[20000][2][2];



//standard
double    overhead = 0.31;
bool      calibration = false;

// CQI & Schedule Map
SCHEDULE_DECISION *** pppSchedule_Map;
double N_pf = 100;
//int SCHEDULE_TYPE = 1;

//receive downlink
int lls_mapping = 0;

//logging point
char path[50];

BS* bs;
MS* ms;
LINK* link;
CHANNEL** channel;
Sector* sector;






